<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>OrderedExecutionSingleExchange.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean.exchanges.executor</a> &gt; <span class="el_source">OrderedExecutionSingleExchange.java</span></div><h1>OrderedExecutionSingleExchange.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean.exchanges.executor;

import java.util.Arrays;
import java.util.Objects;
import java.util.concurrent.atomic.AtomicReferenceArray;
import java.util.function.Consumer;
import java.util.function.IntFunction;
import java.util.function.Supplier;
import java.util.function.ToIntFunction;
import java.util.stream.IntStream;

import io.gitlab.littlesaints.protean.Processor;
import io.gitlab.littlesaints.protean.exchanges.MessageExchange;

/**
 * This executor performs ordered executions.
 * The order of execution for submitted objects is determined by a orderResolver. This orderResolver is provided during the instantiation of this executor.
 *
 * @param &lt;E&gt; The getType of objects to execute upon.
 * @author Varun Anand
 * @since 1.0
 */
class OrderedExecutionSingleExchange&lt;E&gt; extends AbstractExecutionExchange&lt;E&gt; {

    public static final String TYPE = &quot;exchange::execution::java::ordered::single&quot;;

    private static final String nameSuffix = &quot;::OrderedExecutionExchange-single&quot;;

    private final Reader&lt;E&gt; reader;

    private final Thread[] workers;
    private final Runnable[] onCloseOps;

    private final int bufferSize;

    private final ToIntFunction&lt;E&gt; orderResolver;

    private final Reader&lt;E&gt;[] outputExchangeReaders;
    private final Writer&lt;E&gt;[] outputExchangeWriters;

    private final Reader&lt;E&gt;[] inputExchangeReaders;
    private final Writer&lt;E&gt;[] inputExchangeWriters;

    private final AtomicReferenceArray&lt;MessageExchange&lt;E&gt;&gt; inputExchanges;
    private final AtomicReferenceArray&lt;MessageExchange&lt;E&gt;&gt; outputExchanges;

    /**
     * Construct an executor
     *
     * @param name              the name of this exchange. Pass null, if no specific value is needed.
     * @param concurrency       the 'fixed' number of threads to use
     * @param capacity          the buffer size of each thread's message exchange
     * @param exchangeSupplier  the supplier function for creating a message exchange
     * @param processorSupplier the action to perform on a submitted object/event
     * @param orderResolver     the function to resolve the order of execution for submitted objects/events.
     */
    OrderedExecutionSingleExchange(String name, int concurrency, int capacity, IntFunction&lt;MessageExchange&lt;E&gt;&gt; exchangeSupplier, Supplier&lt;Processor&lt;E&gt;&gt; processorSupplier,
                                   ToIntFunction&lt;E&gt; orderResolver) {

<span class="fc" id="L80">        super(name + nameSuffix, processorSupplier, concurrency, exchangeSupplier);</span>
<span class="fc" id="L81">        this.bufferSize = capacity;</span>
<span class="fc" id="L82">        this.orderResolver = orderResolver;</span>
<span class="fc" id="L83">        inputExchanges = new AtomicReferenceArray&lt;&gt;(concurrency);</span>
<span class="fc" id="L84">        outputExchanges = new AtomicReferenceArray&lt;&gt;(concurrency);</span>

<span class="fc" id="L86">        reader = new _Reader();</span>

<span class="fc" id="L88">        workers = new Thread[concurrency];</span>
<span class="fc" id="L89">        onCloseOps = new Runnable[concurrency];</span>

<span class="fc" id="L91">        outputExchangeReaders = new Reader[concurrency];</span>
<span class="fc" id="L92">        outputExchangeWriters = new Writer[concurrency];</span>
<span class="fc" id="L93">        inputExchangeReaders = new Reader[concurrency];</span>
<span class="fc" id="L94">        inputExchangeWriters = new Writer[concurrency];</span>
<span class="fc" id="L95">    }</span>

<span class="fc" id="L97">    private class _Reader extends _ExecutionExchangeReader {</span>
        @Override
        Reader&lt;E&gt; getOutputExchangeReader(int idx) {
<span class="fc" id="L100">            return outputExchangeReaders[idx];</span>
        }
    }

<span class="fc" id="L104">    private class _Writer implements Writer&lt;E&gt; {</span>
        @Override
        public boolean put(final E e) {
<span class="fc" id="L107">            int route = orderResolver.applyAsInt(e) &amp; (concurrency - 1);</span>
<span class="fc" id="L108">            initRoute(route);</span>
<span class="fc" id="L109">            initRouteProcessor(route);</span>
<span class="fc" id="L110">            inputExchangeWriters[route].put(e);</span>
<span class="fc" id="L111">            return true;</span>
        }
    }

    private void initRoute(int route) {
<span class="fc bfc" id="L116" title="All 2 branches covered.">        if (outputExchangeReaders[route] == null) {</span>
<span class="fc" id="L117">            MessageExchange&lt;E&gt; inputExchange = exchangeSupplier.apply(bufferSize);</span>
<span class="fc" id="L118">            inputExchangeReaders[route] = inputExchange.getReader();</span>
<span class="fc" id="L119">            inputExchangeWriters[route] = inputExchange.newWriter();</span>

<span class="fc" id="L121">            MessageExchange&lt;E&gt; outputExchange = exchangeSupplier.apply(bufferSize);</span>
<span class="fc" id="L122">            outputExchangeReaders[route] = outputExchange.getReader();</span>
<span class="fc" id="L123">            outputExchangeWriters[route] = outputExchange.newWriter();</span>

<span class="fc" id="L125">            inputExchanges.set(route, inputExchange);</span>
<span class="fc" id="L126">            outputExchanges.set(route, outputExchange);</span>
        }
<span class="fc" id="L128">    }</span>

    private void initRouteProcessor(int route) {
<span class="fc" id="L131">        Thread worker = workers[route];</span>
<span class="pc bpc" id="L132" title="1 of 4 branches missed.">        if (worker == null || !worker.isAlive()) {</span>
<span class="pc bpc" id="L133" title="1 of 2 branches missed.">            if (worker != null) {</span>
<span class="nc" id="L134">                onCloseOps[route].run();</span>
            }
<span class="fc" id="L136">            final Processor&lt;E&gt; processor = processorSupplier.get();</span>
<span class="fc" id="L137">            final Consumer&lt;E&gt; action = processor.getFunction()::apply;</span>
<span class="fc" id="L138">            workers[route] = new Thread(() -&gt;</span>
<span class="nc" id="L139">                    inputExchangeReaders[route].take(e -&gt; {</span>
<span class="fc" id="L140">                        action.accept(e);</span>
<span class="fc" id="L141">                        outputExchangeWriters[route].put(e);</span>
<span class="fc" id="L142">                        return true;</span>
<span class="fc" id="L143">                    }), getName() + &quot;-worker-&quot; + route);</span>
<span class="fc" id="L144">            workers[route].start();</span>
<span class="fc" id="L145">            onCloseOps[route] = processor::close;</span>
        }
<span class="fc" id="L147">    }</span>

    @Override
    public Reader&lt;E&gt; getReader() {
<span class="fc" id="L151">        return reader;</span>
    }

    @Override
    public Writer&lt;E&gt; newWriter() {
<span class="fc" id="L156">        return new _Writer();</span>
    }

    @Override
    public void shutdown() {
//		while (!isEmpty()) {
//			Thread.yield();
//		}
<span class="nc" id="L164">        IntStream.range(0, concurrency)</span>
<span class="nc" id="L165">                .boxed()</span>
<span class="nc" id="L166">                .map(inputExchanges::get)</span>
<span class="nc" id="L167">                .filter(Objects::nonNull)</span>
<span class="nc" id="L168">                .forEach(MessageExchange::shutdown);</span>
<span class="nc" id="L169">        IntStream.range(0, concurrency)</span>
<span class="nc" id="L170">                .boxed()</span>
<span class="nc" id="L171">                .map(outputExchanges::get)</span>
<span class="nc" id="L172">                .filter(Objects::nonNull)</span>
<span class="nc" id="L173">                .forEach(MessageExchange::shutdown);</span>
<span class="nc" id="L174">        Arrays.stream(workers).filter(Objects::nonNull).filter(Thread::isAlive).forEach(Thread::interrupt);</span>
<span class="nc" id="L175">        Arrays.stream(onCloseOps).filter(Objects::nonNull).forEach(Runnable::run);</span>
<span class="nc" id="L176">    }</span>

    @Override
    public boolean isEmpty() {
<span class="nc" id="L180">        return IntStream.range(0, concurrency)</span>
<span class="nc" id="L181">                .boxed()</span>
<span class="nc" id="L182">                .map(inputExchanges::get)</span>
<span class="nc" id="L183">                .filter(Objects::nonNull)</span>
<span class="nc" id="L184">                .map(MessageExchange::isEmpty)</span>
<span class="nc bnc" id="L185" title="All 4 branches missed.">                .reduce((e1, e2) -&gt; e1 &amp;&amp; e2)</span>
<span class="nc" id="L186">                .orElse(Boolean.FALSE);</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>